package org.omg.appinst;

import java.util.Collection;

public interface ObservableObject {
	String getName();

	ObservableScope getObservableScope();

	ObservableSchema getObservableSchema();

	boolean isSaveObservationEnabled();

	void enableSaveObservation() throws ReturnCodeException;

	void disableSaveObservation() throws ReturnCodeException;

	void attachDataProcessor(DataProcessor processor)
			throws ReturnCodeException;

	DataProcessor detachDataProcessor() throws ReturnCodeException;

	DataProcessor getDataProcessor() throws ReturnCodeException;

	void saveObservation() throws ReturnCodeException;

	Observation[] getObservationHistory();

	void getObservationHistory(Observation[] resultArray)
			throws ReturnCodeException;

	void removeObservationFromHistory(Observation observation)
			throws ReturnCodeException;

	void setValue(int fieldIndex, boolean value) throws ReturnCodeException;

	void setValue(int fieldIndex, byte value) throws ReturnCodeException;

	void setValue(int fieldIndex, short value) throws ReturnCodeException;

	void setValue(int fieldIndex, int value) throws ReturnCodeException;

	void setValue(int fieldIndex, long value) throws ReturnCodeException;

	void setValue(int fieldIndex, float value) throws ReturnCodeException;

	void setValue(int fieldIndex, double value) throws ReturnCodeException;

	void setValue(int fieldIndex, char value) throws ReturnCodeException;

	void setValue(int fieldIndex, String value) throws ReturnCodeException;

	void setValue(int fieldIndex, Boolean value) throws ReturnCodeException;

	void setValue(int fieldIndex, Byte value) throws ReturnCodeException;

	void setValue(int fieldIndex, Short value) throws ReturnCodeException;

	void setValue(int fieldIndex, Integer value) throws ReturnCodeException;

	void setValue(int fieldIndex, Long value) throws ReturnCodeException;

	void setValue(int fieldIndex, Float value) throws ReturnCodeException;

	void setValue(int fieldIndex, Double value) throws ReturnCodeException;

	void setValue(int fieldIndex, Character value) throws ReturnCodeException;

	void setValue(int fieldIndex, boolean[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, byte[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, short[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, int[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, long[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, float[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, double[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, char[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, String[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Boolean[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Byte[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Short[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Integer[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Long[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Float[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Double[] value) throws ReturnCodeException;

	void setValue(int fieldIndex, Character[] value) throws ReturnCodeException;

	<T> void setValue(int fieldIndex, Collection<T> value)
			throws ReturnCodeException;

	boolean isValueBound(int fieldIndex);

	<T> void bindValue(int fieldIndex, FieldValueSource<T> source)
			throws ReturnCodeException;;

	void unbindValue(int fieldIndex) throws ReturnCodeException;;
}
